package cn.sh.stc.sict.theme.hphy.controller.web;

import cn.hutool.core.util.StrUtil;
import cn.sh.stc.sict.cloud.common.core.util.R;
import cn.sh.stc.sict.theme.hpgp.model.HpAppointmentEva;
import cn.sh.stc.sict.theme.hpgp.service.HpAppointmentEvaService;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

@Slf4j
@RestController
@AllArgsConstructor
@Api(tags = "[B]预约评价")
@RequestMapping("/app/eva")
public class AppEvaController {
    private final HpAppointmentEvaService hpAppointmentEvaService;

    @ApiOperation("分页")
    @GetMapping("/page")
    public R hasEavedPage(Page page, HpAppointmentEva eva) {
        LambdaQueryWrapper<HpAppointmentEva> wrapper = Wrappers.lambdaQuery();
        wrapper.like(StrUtil.isNotBlank(eva.getPatientName()), HpAppointmentEva::getPatientName, eva.getPatientName())
                .like(StrUtil.isNotBlank(eva.getHospName()), HpAppointmentEva::getHospName, eva.getHospName())
                .like(StrUtil.isNotBlank(eva.getDeptName()), HpAppointmentEva::getDeptName, eva.getDeptName())
                .like(StrUtil.isNotBlank(eva.getDoctorName()), HpAppointmentEva::getDoctorName, eva.getDoctorName())
                .orderByDesc(HpAppointmentEva::getCreateTime);

        return new R(hpAppointmentEvaService.page(page, wrapper));
    }
}
